<template>

    <q-page class="bg-base">
        <DocumentWrapper ref="wrap">
            <Container :max-height="1" class="full-width column ">

                <WorkerChart :floor="Floor" ref='Chart' v-if="options != null" class="col q-pa-sm" style="box-sizing: border-box" :settings="GraphSettings.StoreValue" :options="options" :days="days"/>
                <q-skeleton v-else type="rect" class="full-width col"/>
                <q-btn color="primary" @click="dialog = true">Change Graph</q-btn>

            </Container>
        </DocumentWrapper>

        <q-dialog persistent v-model="dialog" position="bottom" style="max-width: 800px; width: 100%">
            <div class="bg-base q-pa-lg full-width q-gutter-y-lg">
                <div class="row justify-between">
                    <q-btn icon="get_app" label="download" color="primary" :loading="loading">
                        <q-menu>
                            <q-list>
                                <q-item clickable v-close-popup @click="Download('jpeg')">
                                    <q-item-section>JPEG</q-item-section>
                                </q-item>
                                <q-item clickable v-close-popup @click="Download('png')">
                                    <q-item-section>PNG</q-item-section>
                                </q-item>
                                <q-item clickable v-close-popup @click="Download('pdf')">
                                    <q-item-section>PDF</q-item-section>
                                </q-item>
                            </q-list>
                        </q-menu>
                    </q-btn>
                    <q-btn primary icon="clear" color="primary" @click="dialog = false" label="close"/>

                </div>
                <WorkerChartOptions :floors="floors" :days="days"/>
            </div>
        </q-dialog>
    </q-page>
</template>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import {GraphExportType} from "src/classLibrary/Constants";
import {WorkerGraphOption, WorkerGraphType} from "src/classLibrary/Charting/WorkerChart";
import {SortType} from "@kirinnee/core";
import {format} from "date-fns";
import Container from "components/Core/Container.vue";
import WorkerChart from "components/Charts/WorkerChart.vue";
import WorkerChartOptions from "components/Charts/WorkerChartOptions.vue";
import {FloorPrincipalResponse} from "src/classLibrary/APIModels/core/floorPrincipalResponse";
import DocumentWrapper from "components/Core/DocumentWrapper.vue";

@Component({
    components: {DocumentWrapper, WorkerChartOptions, WorkerChart, Container}
})
export default class WorkerAnalytics extends Vue {
    routeParams = {
        subId: '',
        workerId: '',
    }
    dialog = false;
    routeQueries = {
        range: 'false',
        startTime: '',
        endTime: '',
        type: 'horizontalBar',
        merge: 'true',
        floorId: '',
        specifyFloor: 'false',
    }
    loading = false;

    days: string[] = [];
    options: WorkerGraphOption | null = null

    get Floor(): FloorPrincipalResponse | null {
        return this.floors.Find(x => x.id === this.routeQueries.floorId);
    }

    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    async Download(type: GraphExportType) {
        this.loading = true;
        await (this.$refs.Chart as any).Download(type);
        this.loading = false;
    }

    created() {
        this.Store.StoreValue.filter = 'graph';
        this.Store.StoreValue.rightIcon = 'tune';
    }

    destroyed() {
        this.Store.StoreValue.filter = '';
        this.Store.StoreValue.rightIcon = '';
    }

    floors: FloorPrincipalResponse[] = [];

    async loadFloors() {
        const pid = this.PersistentStore.StoreValue.project;
        const token = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<FloorPrincipalResponse[]>(`Floor?projectId=${pid}`, null, token);
        if (r.isErr()) {
            this.Wrap.SubmitError(r.unwrapErr());
        }
        this.floors = r.unwrap();
    }

    async init() {
        const token = await this.$auth.AnalyticsToken;
        const pid = this.PersistentStore.StoreValue.project;
        const dayR = await this.$analyticsApi.Get<string[]>(`Analytics/${pid}/Worker/${this.routeParams.workerId}/days`, null, token);
        if (dayR.isOk()) {
            this.Store.StoreValue.filter = 'graph';
            this.Store.StoreValue.rightIcon = 'tune';
            const unwrapped = dayR.unwrap();
            const first = unwrapped.Sort(SortType.Descending, (s: string) => new Date(s) as any as number).Take();
            if (this.routeQueries.startTime === '' && this.routeQueries.endTime === '' && first != null) {
                const date = format(new Date(first), "yyyy/MM/dd");
                this.routeQueries.startTime = date;
                this.routeQueries.endTime = date;
            }
            this.days = unwrapped.Map(x => format(new Date(x), "yyyy/MM/dd"));
            this.options = this.Graph();
        } else {
            this.Wrap.SubmitError(dayR.unwrapErr());
        }
        await this.loadFloors()
    }

    Graph(): WorkerGraphOption {
        const pid = this.PersistentStore.StoreValue.project
        return {
            type: this.routeQueries.type as WorkerGraphType,
            startTime: this.routeQueries.startTime,
            endTime: this.routeQueries.endTime,
            projectId: pid,
            workerId: this.routeParams.workerId,
            subId: this.routeParams.subId,
            range: this.routeQueries.range === 'true',
            merge: this.routeQueries.merge === 'true',
            floorId: this.routeQueries.specifyFloor === 'true' ? this.routeQueries.floorId : undefined,
        }
    }

}


</script>

<style lang='scss' scoped>

</style>
